diff -Naur newlib-1.19.0.orig/newlib/libc/sys/sysnecv850/Makefile.am newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/sysnecv850/Makefile.am
--- newlib-1.19.0.orig/newlib/libc/sys/sysnecv850/Makefile.am	2010-09-09 16:54:24.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/sysnecv850/Makefile.am	2011-05-17 07:25:06.795153792 +0200
@@ -16,7 +16,7 @@
 	$(lpfx)open.o $(lpfx)pipe.o $(lpfx)read.o $(lpfx)link.o \
 	$(lpfx)sbrk.o $(lpfx)stat.o $(lpfx)time.o $(lpfx)trap.o \
 	$(lpfx)unlink.o $(lpfx)utime.o $(lpfx)wait.o $(lpfx)write.o \
-	$(lpfx)times.o $(lpfx)gettime.o
+	$(lpfx)times.o $(lpfx)gettime.o $(lpfx)rename.o
 else
 extra_objs =
 endif
@@ -27,7 +27,7 @@
 	execv.c execve.c fork.c fstat.c getpid.c isatty.c \
 	kill.c lseek.c open.c pipe.c read.c link.c \
 	sbrk.c stat.c time.c trap.S unlink.c utime.c wait.c write.c \
-	times.c gettime.c
+	times.c gettime.c rename.c
 lib_a_SOURCES =
 lib_a_DEPENDENCIES = $(extra_objs)
 lib_a_CCASFLAGS = $(AM_CCASFLAGS)
diff -Naur newlib-1.19.0.orig/newlib/libc/sys/sysnecv850/rename.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/sysnecv850/rename.c
--- newlib-1.19.0.orig/newlib/libc/sys/sysnecv850/rename.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/sysnecv850/rename.c	2011-05-17 07:25:06.795153792 +0200
@@ -0,0 +1,17 @@
+#include <_ansi.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include "sys/syscall.h"
+
+int errno;
+
+int __trap0 (int function, int p1, int p2, int p3);
+
+#define TRAP0(f, p1, p2, p3) __trap0(f, (int)(p1), (int)(p2), (int)(p3))
+
+int
+rename (const char *oldpath,
+	 const char *newpath)
+{
+  return TRAP0 (SYS_rename, oldpath, newpath, 0);
+}
diff -Naur newlib-1.19.0.orig/newlib/libc/sys/sysnecv850/sys/syscall.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/sysnecv850/sys/syscall.h
--- newlib-1.19.0.orig/newlib/libc/sys/sysnecv850/sys/syscall.h	2000-02-17 20:39:50.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/sysnecv850/sys/syscall.h	2011-05-17 07:25:06.796153807 +0200
@@ -29,6 +29,7 @@
 #define	SYS_execve	59
 #define   SYS_times       43
 #define SYS_gettimeofday 116
+#define SYS_rename	134
 
 #define SYS_utime       201 /* not really a system call */
 #define SYS_wait        202 /* nor is this */
diff -Naur newlib-1.19.0.orig/newlib/libc/sys/sysnecv850/trap.S newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/sysnecv850/trap.S
--- newlib-1.19.0.orig/newlib/libc/sys/sysnecv850/trap.S	2000-02-17 20:39:50.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/sysnecv850/trap.S	2011-05-17 07:25:06.796153807 +0200
@@ -2,9 +2,9 @@
 	.global	___trap0
 ___trap0:
 	trap 31
-	tst r10,r10
+	tst r11,r11
 	bz .L0
 	movhi hi(_errno),r0,r6
-	st.w r10,lo(_errno)[r6]
+	st.w r11,lo(_errno)[r6]
 .L0:
 	jmp [r31]
diff -Naur newlib-1.19.0.orig/newlib/libc/sys/sysnecv850/unlink.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/sysnecv850/unlink.c
--- newlib-1.19.0.orig/newlib/libc/sys/sysnecv850/unlink.c	2000-02-17 20:39:50.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/sysnecv850/unlink.c	2011-05-17 07:25:06.796153807 +0200
@@ -10,7 +10,7 @@
 #define TRAP0(f, p1, p2, p3) __trap0(f, (int)(p1), (int)(p2), (int)(p3))
 
 int
-_unlink ()
+_unlink (const char *path)
 {
-  return -1;
+  return TRAP0 (SYS_unlink, path, 0, 0);
 }
diff -Naur newlib-1.19.0.orig/newlib/libc/time/strptime.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/time/strptime.c
--- newlib-1.19.0.orig/newlib/libc/time/strptime.c	2010-01-22 14:03:42.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/time/strptime.c	2011-05-17 07:25:06.796153807 +0200
@@ -40,6 +40,16 @@
 
 #define _ctloc(x) (_CurrentTimeLocale->x)
 
+static _CONST int _DAYS_BEFORE_MONTH[12] =
+{0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334};
+
+#define SET_MDAY 1
+#define SET_MON  2
+#define SET_YEAR 4
+#define SET_WDAY 8
+#define SET_YDAY 16
+#define SET_YMD  (SET_YEAR | SET_MON | SET_MDAY)
+
 /*
  * tm_year is relative this year 
  */
@@ -78,8 +88,8 @@
 {
     int ret = 4;
 
-    for (; year > 1970; --year)
-	ret = (ret + 365 + is_leap_year (year) ? 1 : 0) % 7;
+    while (--year >= 1970)
+	ret = (ret + 365 + is_leap_year (year)) % 7;
     return ret;
 }
 
@@ -147,6 +157,7 @@
 	struct tm *timeptr)
 {
     char c;
+    int ymd = 0;
 
     struct lc_time_T *_CurrentTimeLocale = __get_current_time_locale ();
     for (; (c = *format) != '\0'; ++format) {
@@ -166,18 +177,21 @@
 		if (ret < 0)
 		    return NULL;
 		timeptr->tm_wday = ret;
+		ymd |= SET_WDAY;
 		break;
 	    case 'a' :
 		ret = match_string (&buf, _ctloc (wday));
 		if (ret < 0)
 		    return NULL;
 		timeptr->tm_wday = ret;
+		ymd |= SET_WDAY;
 		break;
 	    case 'B' :
 		ret = match_string (&buf, _ctloc (month));
 		if (ret < 0)
 		    return NULL;
 		timeptr->tm_mon = ret;
+		ymd |= SET_MON;
 		break;
 	    case 'b' :
 	    case 'h' :
@@ -185,6 +199,7 @@
 		if (ret < 0)
 		    return NULL;
 		timeptr->tm_mon = ret;
+		ymd |= SET_MON;
 		break;
 	    case 'C' :
 		ret = strtol (buf, &s, 10);
@@ -192,18 +207,21 @@
 		    return NULL;
 		timeptr->tm_year = (ret * 100) - tm_year_base;
 		buf = s;
+		ymd |= SET_YEAR;
 		break;
 	    case 'c' :		/* %a %b %e %H:%M:%S %Y */
 		s = strptime (buf, _ctloc (c_fmt), timeptr);
 		if (s == NULL)
 		    return NULL;
 		buf = s;
+		ymd |= SET_WDAY | SET_YMD;
 		break;
 	    case 'D' :		/* %m/%d/%y */
 		s = strptime (buf, "%m/%d/%y", timeptr);
 		if (s == NULL)
 		    return NULL;
 		buf = s;
+		ymd |= SET_YMD;
 		break;
 	    case 'd' :
 	    case 'e' :
@@ -212,6 +230,7 @@
 		    return NULL;
 		timeptr->tm_mday = ret;
 		buf = s;
+		ymd |= SET_MDAY;
 		break;
 	    case 'H' :
 	    case 'k' :
@@ -238,6 +257,7 @@
 		    return NULL;
 		timeptr->tm_yday = ret - 1;
 		buf = s;
+		ymd |= SET_YDAY;
 		break;
 	    case 'm' :
 		ret = strtol (buf, &s, 10);
@@ -245,6 +265,7 @@
 		    return NULL;
 		timeptr->tm_mon = ret - 1;
 		buf = s;
+		ymd |= SET_MON;
 		break;
 	    case 'M' :
 		ret = strtol (buf, &s, 10);
@@ -306,6 +327,7 @@
 		    return NULL;
 		timeptr->tm_wday = ret - 1;
 		buf = s;
+		ymd |= SET_WDAY;
 		break;
 	    case 'w' :
 		ret = strtol (buf, &s, 10);
@@ -313,6 +335,7 @@
 		    return NULL;
 		timeptr->tm_wday = ret;
 		buf = s;
+		ymd |= SET_WDAY;
 		break;
 	    case 'U' :
 		ret = strtol (buf, &s, 10);
@@ -320,6 +343,7 @@
 		    return NULL;
 		set_week_number_sun (timeptr, ret);
 		buf = s;
+		ymd |= SET_YDAY;
 		break;
 	    case 'V' :
 		ret = strtol (buf, &s, 10);
@@ -327,6 +351,7 @@
 		    return NULL;
 		set_week_number_mon4 (timeptr, ret);
 		buf = s;
+		ymd |= SET_YDAY;
 		break;
 	    case 'W' :
 		ret = strtol (buf, &s, 10);
@@ -334,12 +359,14 @@
 		    return NULL;
 		set_week_number_mon (timeptr, ret);
 		buf = s;
+		ymd |= SET_YDAY;
 		break;
 	    case 'x' :
 		s = strptime (buf, _ctloc (x_fmt), timeptr);
 		if (s == NULL)
 		    return NULL;
 		buf = s;
+		ymd |= SET_YMD;
 		break;
 	    case 'X' :
 		s = strptime (buf, _ctloc (X_fmt), timeptr);
@@ -356,6 +383,7 @@
 		else
 		    timeptr->tm_year = ret;
 		buf = s;
+		ymd |= SET_YEAR;
 		break;
 	    case 'Y' :
 		ret = strtol (buf, &s, 10);
@@ -363,6 +391,7 @@
 		    return NULL;
 		timeptr->tm_year = ret - tm_year_base;
 		buf = s;
+		ymd |= SET_YEAR;
 		break;
 	    case 'Z' :
 		/* Unsupported. Just ignore.  */
@@ -390,6 +419,58 @@
 		return NULL;
 	}
     }
+
+    if ((ymd & SET_YMD) == SET_YMD) {
+	/* all of tm_year, tm_mon and tm_mday, but... */
+
+	if (!(ymd & SET_YDAY)) {
+	    /* ...not tm_yday, so fill it in */
+	    timeptr->tm_yday = _DAYS_BEFORE_MONTH[timeptr->tm_mon]
+		+ timeptr->tm_mday;
+	    if (!is_leap_year (timeptr->tm_year + tm_year_base)
+		|| timeptr->tm_mon < 2)
+	    {
+		timeptr->tm_yday--;
+	    }
+	    ymd |= SET_YDAY;
+	}
+    }
+    else if ((ymd & (SET_YEAR | SET_YDAY)) == (SET_YEAR | SET_YDAY)) {
+	/* both of tm_year and tm_yday, but... */
+
+	if (!(ymd & SET_MON)) {
+	    /* ...not tm_mon, so fill it in, and/or... */
+	    if (timeptr->tm_yday < _DAYS_BEFORE_MONTH[1])
+		timeptr->tm_mon = 0;
+	    else {
+		int leap = is_leap_year (timeptr->tm_year + tm_year_base);
+		int i;
+		for (i = 2; i < 12; ++i) {
+		    if (timeptr->tm_yday < _DAYS_BEFORE_MONTH[i] + leap)
+			break;
+		}
+		timeptr->tm_mon = i - 1;
+	    }
+	}
+
+	if (!(ymd & SET_MDAY)) {
+	    /* ...not tm_mday, so fill it in */
+	    timeptr->tm_mday = timeptr->tm_yday
+		- _DAYS_BEFORE_MONTH[timeptr->tm_mon];
+	    if (!is_leap_year (timeptr->tm_year + tm_year_base)
+		|| timeptr->tm_mon < 2)
+	    {
+		timeptr->tm_mday++;
+	    }
+	}
+    }
+
+    if ((ymd & (SET_YEAR | SET_YDAY | SET_WDAY)) == (SET_YEAR | SET_YDAY)) {
+	/* fill in tm_wday */
+	int fday = first_day (timeptr->tm_year + tm_year_base);
+	timeptr->tm_wday = (fday + timeptr->tm_yday) % 7;
+    }
+
     return (char *)buf;
 }
 
diff -Naur newlib-1.19.0.orig/newlib/libc/xdr/xdr.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/xdr/xdr.c
--- newlib-1.19.0.orig/newlib/libc/xdr/xdr.c	2010-03-02 13:05:18.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/xdr/xdr.c	2011-05-17 07:25:06.796153807 +0200
@@ -113,7 +113,7 @@
 #elif INT_MAX == LONG_MAX
   return xdr_long (xdrs, (long *) ip);
 #else
-# error Unexpeced integer sizes in xdr_int()
+# error Unexpected integer sizes in xdr_int()
 #endif
 }
 
@@ -148,7 +148,7 @@
 #elif UINT_MAX == ULONG_MAX
   return xdr_u_long (xdrs, (u_long *) up);
 #else
-# error Unexpeced integer sizes in xdr_int()
+# error Unexpected integer sizes in xdr_int()
 #endif
 }
 
diff -Naur newlib-1.19.0.orig/newlib/libc/xdr/xdr_private.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/xdr/xdr_private.h
--- newlib-1.19.0.orig/newlib/libc/xdr/xdr_private.h	2010-03-02 13:05:18.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/xdr/xdr_private.h	2011-05-17 07:25:06.797153822 +0200
@@ -25,6 +25,7 @@
 
 #include <_ansi.h>
 #include <stdarg.h>
+#include <stdint.h>
 #include <sys/param.h>
 
 /* avoid including stdio header here */
diff -Naur newlib-1.19.0.orig/newlib/libc/xdr/xdr_rec.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/xdr/xdr_rec.c
--- newlib-1.19.0.orig/newlib/libc/xdr/xdr_rec.c	2010-03-02 13:05:18.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/xdr/xdr_rec.c	2011-05-17 07:25:06.797153822 +0200
@@ -51,6 +51,7 @@
 #include <assert.h>
 #include <unistd.h>
 #include <errno.h>
+#include <limits.h>
 
 #include <rpc/types.h>
 #include <rpc/xdr.h>
diff -Naur newlib-1.19.0.orig/newlib/libm/common/modfl.c newlib-1.19.0-rtems4.11-20110517/newlib/libm/common/modfl.c
--- newlib-1.19.0.orig/newlib/libm/common/modfl.c	2009-04-18 00:15:43.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libm/common/modfl.c	2011-05-17 07:25:06.797153822 +0200
@@ -36,7 +36,7 @@
 long double
 modfl (long double x, long double *iptr)
 {
-  return modf(x, iptr);
+  return modf(x, (double*) iptr);
 }
 #endif
 
diff -Naur newlib-1.19.0.orig/newlib/libm/common/s_round.c newlib-1.19.0-rtems4.11-20110517/newlib/libm/common/s_round.c
--- newlib-1.19.0.orig/newlib/libm/common/s_round.c	2009-03-25 20:13:01.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libm/common/s_round.c	2011-05-17 07:25:06.797153822 +0200
@@ -68,7 +68,7 @@
           msw &= 0x80000000;
           if (exponent_less_1023 == -1)
             /* Result is +1.0 or -1.0. */
-            msw |= (1023 << 20);
+            msw |= ((__int32_t)1023 << 20);
           lsw = 0;
         }
       else
diff -Naur newlib-1.19.0.orig/newlib/libm/complex/cproj.c newlib-1.19.0-rtems4.11-20110517/newlib/libm/complex/cproj.c
--- newlib-1.19.0.orig/newlib/libm/complex/cproj.c	2010-10-19 00:40:24.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libm/complex/cproj.c	2011-05-17 07:25:06.797153822 +0200
@@ -93,7 +93,7 @@
 {
 	double_complex w = { .z = z };
 
-	if (isinf(creal(z) || isinf(cimag(z)))) {
+	if (isinf(creal(z)) || isinf(cimag(z))) {
 #ifdef __INFINITY
 		REAL_PART(w) = __INFINITY;
 #else
diff -Naur newlib-1.19.0.orig/newlib/libm/complex/cprojf.c newlib-1.19.0-rtems4.11-20110517/newlib/libm/complex/cprojf.c
--- newlib-1.19.0.orig/newlib/libm/complex/cprojf.c	2010-10-08 12:35:14.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libm/complex/cprojf.c	2011-05-17 07:25:06.798153837 +0200
@@ -55,7 +55,7 @@
 {
 	float_complex w = { .z = z };
 
-	if (isinf(crealf(z) || isinf(cimagf(z)))) {
+	if (isinf(crealf(z)) || isinf(cimagf(z))) {
 #ifdef __INFINITY
 		REAL_PART(w) = __INFINITY;
 #else
diff -Naur newlib-1.19.0.orig/newlib/libm/math/e_scalb.c newlib-1.19.0-rtems4.11-20110517/newlib/libm/math/e_scalb.c
--- newlib-1.19.0.orig/newlib/libm/math/e_scalb.c	2000-02-17 20:39:51.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libm/math/e_scalb.c	2011-05-17 07:25:06.798153837 +0200
@@ -17,6 +17,7 @@
  * should use scalbn() instead.
  */
 
+#include <limits.h>
 #include "fdlibm.h"
 
 #ifndef _DOUBLE_IS_32BITS
@@ -46,8 +47,17 @@
 	    else       return x/(-fn);
 	}
 	if (rint(fn)!=fn) return (fn-fn)/(fn-fn);
+#if (INT_MAX < 65000)
+	if ( fn > (double) INT_MAX) return scalbn(x, INT_MAX);
+#else
 	if ( fn > 65000.0) return scalbn(x, 65000);
-	if (-fn > 65000.0) return scalbn(x,-65000);
+#endif
+
+#if (INT_MIN > -65000)
+        if (fn < (double) INT_MIN) return scalbn(x,INT_MIN);
+#else
+	if (fn < -65000.0) return scalbn(x,-65000);
+#endif
 	return scalbn(x,(int)fn);
 #endif
 }
diff -Naur newlib-1.19.0.orig/newlib/libm/math/wf_tgamma.c newlib-1.19.0-rtems4.11-20110517/newlib/libm/math/wf_tgamma.c
--- newlib-1.19.0.orig/newlib/libm/math/wf_tgamma.c	2007-09-04 19:33:10.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libm/math/wf_tgamma.c	2011-05-17 07:25:06.798153837 +0200
@@ -43,3 +43,17 @@
 	return y;
 #endif
 }
+
+#ifdef _DOUBLE_IS_32BITS
+
+#ifdef __STDC__
+	double tgamma(double x)
+#else
+	double tgamma(x)
+	double x;
+#endif
+{
+	return (double) tgammaf((float) x);
+}
+
+#endif /* defined(_DOUBLE_IS_32BITS) */
diff -Naur newlib-1.19.0.orig/newlib/libm/math/w_tgamma.c newlib-1.19.0-rtems4.11-20110517/newlib/libm/math/w_tgamma.c
--- newlib-1.19.0.orig/newlib/libm/math/w_tgamma.c	2002-06-07 23:59:56.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libm/math/w_tgamma.c	2011-05-17 07:25:06.798153837 +0200
@@ -17,6 +17,8 @@
 
 #include "fdlibm.h"
 
+#ifndef _DOUBLE_IS_32BITS
+
 #ifdef __STDC__
 	double tgamma(double x)
 #else
@@ -42,3 +44,5 @@
 	return y;
 #endif
 }
+
+#endif /* defined(_DOUBLE_IS_32BITS) */
diff -Naur newlib-1.19.0.orig/newlib/MAINTAINERS newlib-1.19.0-rtems4.11-20110517/newlib/MAINTAINERS
--- newlib-1.19.0.orig/newlib/MAINTAINERS	2010-12-16 22:58:38.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/MAINTAINERS	2011-05-17 07:25:06.765153334 +0200
@@ -6,7 +6,7 @@
 The official maintainers of newlib:
 
 Jeff Johnston			jjohnstn@redhat.com
-Corinna	Vinschen		corinna@vinchen.de
+Corinna Vinschen		corinna@vinschen.de
 
 
 		     Various Domain Maintainers
diff -Naur newlib-1.19.0.orig/newlib/Makefile.am newlib-1.19.0-rtems4.11-20110517/newlib/Makefile.am
--- newlib-1.19.0.orig/newlib/Makefile.am	2010-12-16 22:58:38.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/Makefile.am	2011-05-17 07:25:06.765153334 +0200
@@ -81,7 +81,7 @@
 	libc.a
 endif
 
-noinst_DATA = stmp-targ-include
+BUILT_SOURCES = stmp-targ-include
 
 toollib_DATA = $(CRT0) $(CRT1)
 
@@ -255,7 +255,7 @@
 	  done
 	touch $@
 
-CLEANFILES = targ-include stmp-targ-include
+CLEANFILES = stmp-targ-include
 
 install-data-local:	install-toollibLIBRARIES
 if USE_LIBTOOL
@@ -279,10 +279,6 @@
 	     $(INSTALL_DATA) $$i $(DESTDIR)$(tooldir)/include/machine/`basename $$i`; \
 	    else true; fi ; \
 	  done; \
-	  $(mkinstalldirs) $(DESTDIR)$(tooldir)/include/rpc; \
-	  for i in $(srcdir)/libc/include/rpc/*.h; do \
-	   $(INSTALL_DATA) $$i $(DESTDIR)$(tooldir)/include/rpc/`basename $$i`; \
-	  done; \
 	  $(mkinstalldirs) $(DESTDIR)$(tooldir)/include/sys; \
 	  for i in $(srcdir)/libc/include/sys/*.h; do \
 	   $(INSTALL_DATA) $$i $(DESTDIR)$(tooldir)/include/sys/`basename $$i`; \
@@ -430,3 +426,6 @@
 	else \
 	   echo "WARNING: could not find \`runtest'" 1>&2 ; \
 	fi
+
+clean-local:
+	-rm -rf targ-include
